#I
"""

On a un nombre dénormalisé, donc l'exposant vaut 0. Le nombre vaut ma 2^(-126).
La valeur maximale de ma vaut 1/2+1/4+....+1/2^(23). On peut calculer cette somme de deux façons :
- on reconnaît une suite géométrique de raison 1/2 et de premier terme 1/2 donc 1/2*(1-(1/2)^23)/(1-1/2)=1-1/2^(23)
- on remarque que si on rajoute 1 au dernier bit, on obtient 1 (car 1/2^n+1/2^n=1/2^(n-1)), ce qui mène au même résultat.
Le plus grand nombre dénormalisé vaut donc :
2^(-126)*(1-1/2^23)~ 2^(-126)~ 2^4 *1/2^130 ~ 16*1/(2^(10))^13~16/10^39~1,6.10^-38


"""

#II
#on code déjà l'extraction
#on va le faire sans numpy
def sous_matrice(i,M):
    M_retour=[]
    n=len(M)
    for ii in range(n):
        ligne=[]
        for j in range(1,n): #on supprime la première colonne
            if ii!=i:
                ligne.append(M[ii][j])
        if ii!=i:
            M_retour.append(ligne)
    return M_retour
            
 
        
def det(M):
    if len(M)==1:
        return M[0][0]
    else:
        somme=0
        n=len(M)
        for i in range(n):
            Mi=sous_matrice(i,M)
            somme+=(-1)**i*M[i][0]*det(Mi)
        return somme
        
M=[[2,2,3],[4,5,6],[7,8,9]]
print(det(M))

"""*
sous_matrice est fini car il n'implique que des boucles for
pour montrer la finitude de det, il faut remarquer que la taille de la matrice appelée diminue de 1 à chaque appel. On tombe donc nécessairement sur le cas de taille 1.

Pour la complexité, pour une matrice de taille n:
- on fait n appels à det
- dans cet appel sous_matrice est de complexité n

On a donc si on note T_n la complexité temporelle :
T_n=n*T_(n-1)+n

Pour n grand (asymptotique), on a donc une complexité en n! (en négligeant la partie en +n)

"""
                